/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package formen;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

/**
 *
 * @author micha
 */
public class Dreieck extends Form {

    Punkt a, b, c;

    double getFlaeche() {
        Punkt ab = a.diff(b);
        Punkt ac = a.diff(c);
        double kreuz = ac.kreuz(ab);
        return Math.sqrt(kreuz*kreuz)/2;
    }

    void verschieben(Punkt vektor) {
        a=a.sum(vektor);
        b=b.sum(vektor);
        c=c.sum(vektor);
    }

    public void drehen(double winkel) {
        DrehMatrix dm = new DrehMatrix(winkel);
        a = a.drehen(dm);
        b = b.drehen(dm);
        c = c.drehen(dm);
    }

    public Dreieck(Punkt a, Punkt b, Punkt c, Color color) {
        super(a);
        this.a = a;
        this.b = b;
        this.c = c;
        this.farbe = color;
    }

    public Dreieck(Punkt a, Punkt b, Punkt c){
        this(a,b,c, Color.BLACK);
    }
    
    public Punkt getA() {
        return a;
    }

    public void setA(Punkt a) {
        this.a = a;
    }

    public Punkt getB() {
        return b;
    }

    public void setB(Punkt b) {
        this.b = b;
    }

    public Punkt getC() {
        return c;
    }

    public void setC(Punkt c) {
        this.c = c;
    }
    
    public void zeichnen(Graphics g) {
        //koordinaten
        int ax, ay, bx, by, cx, cy;

        ax = (int) (this.a.getX() + 0.5);
        ay = -(int) (this.a.getY() + 0.5);

        bx = (int) (this.b.getX() + 0.5);
        by = -(int) (this.b.getY() + 0.5);

        cx = (int) (this.c.getX() + 0.5);
        cy = -(int) (this.c.getY() + 0.5);

        g.setColor(this.farbe);
        g.drawLine(ax, ay, bx, by);
        g.drawLine(bx, by, cx, cy);
        g.drawLine(cx, cy, ax, ay);
        g.setColor(Color.BLACK);
        g.drawString("a", ax, ay);
        g.drawString("b", bx, by);
        g.drawString("c", cx, cy);
        g.drawString(this.getFlaeche()+"", cx, cy);

    }

    @Override
    double getUmfang() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
    

}
